/* Nabi - X Input Method server for hangul
 * Copyright (C) 2003 Choe Hwanjin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#define ENCODING_EUCKR 1
typedef struct _NabiIC NabiIC;
struct _NabiIC {
	int index;
	wchar_t stack[12];
	int lindex;
	int vindex;
	int tindex;
	wchar_t choseong[4];
	wchar_t jungseong[4];
	wchar_t jongseong[4];
};

#define nabi_ic_is_empty(ic)        ((ic)->choseong[0]  == 0 &&     \
                                     (ic)->jungseong[0] == 0 &&     \
                                     (ic)->jongseong[0] == 0 )
NabiIC * nabi_ic_create(void);
void nabi_ic_destroy(NabiIC * ic);
void nabi_ic_buf_clear(NabiIC * ic);
void nabi_ic_push(NabiIC * ic, wchar_t ch);
wchar_t nabi_ic_peek(NabiIC * ic);
wchar_t nabi_ic_pop(NabiIC * ic);
void nabi_ic_get_preedit_string(NabiIC * ic, char * utf8, int buflen,
					int * len, int * size);
void nabi_ic_preedit_insert(NabiIC * ic);
void nabi_ic_preedit_update(NabiIC * ic);
int nabi_ic_commit(NabiIC * ic);
int nabi_ic_commit_unicode(NabiIC * ic, wchar_t ch);
int nabi_ic_commit_keyval(NabiIC * ic, wchar_t ch, int keyval);
