#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include <iconv.h>
#include "utfto.h"
#include "hangul.h"

static iconv_t utf8_to_euckr_cd = (iconv_t) -1;

int
is_valid_euckr(wchar_t choseong, wchar_t jungseong, wchar_t jongseong)
{
	wchar_t check_char;
	char utf_buf[6] = {0, };
	check_char = hangul_jamo_to_syllable(choseong, jungseong, jongseong);
	hangul_wchar_to_utf8(check_char, utf_buf, 6);
	char euc_buf[64] = {0, };
	int ret;

	ret = utf8_to_euckr(utf_buf, euc_buf);
	if(ret)
		return 1;
	return 0;
}

int
utf8_to_euckr(char * utf8buf, char * eucbuf)
{
	int in_len, out_len;
	char *in_p, *out_p;
	size_t ret = (size_t) -1;

	if(utf8_to_euckr_cd == (iconv_t) -1) {
		utf8_to_euckr_cd = iconv_open("EUC-KR", "UTF-8");
		if(utf8_to_euckr_cd == (iconv_t) -1) {
			fprintf(stderr, "iconv: utf8 to euckr\n");
			exit(-1);
		}
	}
	in_p = utf8buf;
	out_p = eucbuf;
	in_len = strlen(utf8buf);
	out_len = 64;
	ret = iconv(utf8_to_euckr_cd, &in_p, &in_len, &out_p, &out_len);

	if(ret == (size_t) -1)
		return 0;
	return 1;
}
